#
# FOURJS_START_COPYRIGHT(U,2000)
# Property of Four Js*
# (c) Copyright Four Js 2000, 2012. All Rights Reserved.
# * Trademark of Four Js Development Tools Europe Ltd
#   in the United States and elsewhere
# 
# Four Js and its suppliers do not warrant or guarantee that these samples
# are accurate and suitable for your purposes. Their inclusion is purely for
# information purposes only.
# FOURJS_END_COPYRIGHT
#
IMPORT xml
GLOBALS "ws_calculator.inc"


MAIN
  DEFINE op1        INTEGER
  DEFINE op2        INTEGER
  DEFINE result     INTEGER
  DEFINE remaind    INTEGER
  DEFINE terminate  INTEGER
  DEFINE wsstatus   INTEGER

  DEFINE error_message STRING
  
  CLOSE WINDOW SCREEN
  
  IF num_args()==1 THEN
    LET Calculator_CalculatorPortTypeEndpoint.Address.URI = Retrieve_URL()
  END IF  
  
  OPEN WINDOW w1 WITH FORM "calculatorClient" ATTRIBUTE (TEXT="Soap 1.1 Web Services calculator demo")
  
  LET terminate=false
  WHILE NOT terminate
    INPUT BY NAME op1,op2 ATTRIBUTE (UNBUFFERED)
 
     ON ACTION plus
       CALL do_maths_using_dom(op1, op2, "plus") RETURNING wsstatus, result, remaind, error_message
       IF wsstatus = 0 THEN
          DISPLAY BY NAME result,remaind
          DISPLAY error_message TO msg
        ELSE
          DISPLAY error_message TO msg
        END IF
        
     ON ACTION minus
       CALL do_maths_using_dom(op1, op2, "minus") RETURNING wsstatus, result, remaind, error_message
       IF wsstatus = 0 THEN
          DISPLAY BY NAME result,remaind
          DISPLAY error_message TO msg
        ELSE
          DISPLAY error_message TO msg
        END IF
        
     ON ACTION multiply
       CALL do_maths_using_dom(op1, op2, "multiply") RETURNING wsstatus, result, remaind, error_message
       IF wsstatus = 0 THEN
          DISPLAY BY NAME result,remaind
          DISPLAY error_message TO msg
        ELSE
          DISPLAY error_message TO msg
        END IF
        
     ON ACTION divide
       CALL do_maths_using_dom(op1, op2, "divide") RETURNING wsstatus, result , remaind, error_message
       IF wsstatus = 0 THEN
          DISPLAY BY NAME result,remaind
          DISPLAY error_message TO msg
        ELSE
          DISPLAY error_message TO msg
        END IF
     ON ACTION close
       LET terminate=true
       EXIT INPUT       
    END INPUT
  END WHILE    

  CLOSE WINDOW w1
  
END MAIN

FUNCTION Retrieve_URL()
  DEFINE url STRING
  DEFINE custo  STRING
  OPEN WINDOW w2 WITH FORM "enterURL" ATTRIBUTE (TEXT="Web Services URL",STYLE="naked")
  LET url = arg_val(1)
  INPUT BY NAME url WITHOUT DEFAULTS ATTRIBUTE (UNBUFFERED)
    ON ACTION ACCEPT
      EXIT INPUT
    ON CHANGE url
      IF url=="Customize" THEN
        LET url="http://host:port/Calculator"
        PROMPT "Enter your URL" FOR url ATTRIBUTES (WITHOUT DEFAULTS)
        IF NOT INT_FLAG THEN
          LET INT_FLAG = false
          EXIT INPUT
        ELSE
          LET url = arg_val(1)
        END IF
      END IF
    ON ACTION CANCEL
      EXIT PROGRAM
  END INPUT
  LET INT_FLAG = false
  CLOSE WINDOW w2
  RETURN url
END FUNCTION

FUNCTION fillcombourls(cb)
  DEFINE cb ui.ComboBox
  IF cb.getTag()=="COMBO" THEN
    CALL cb.addItem(arg_val(1),"(Standalone) "||arg_val(1))
    CALL cb.addItem("http://localhost:6394/ws/r/demo/Calculator","(Httpdispatch) http://localhost:6394/ws/r/demo/Calculator")
    CALL cb.addItem("http://localhost/gas/ws/r/demo/Calculator","(FastCGI) http://localhost/gas/ws/r/demo/Calculator")
    CALL cb.addItem("http://localhost/gas/ws/r/demo/Calculator","(ISAPI) http://localhost/gas/ws/r/demo/Calculator")
    CALL cb.addItem("http://localhost/java-j2eedispatch/ws/r/demo/Calculator","(Java) http://localhost/java-j2eedispatch/ws/r/demo/Calculator")
    CALL cb.addItem("Customize","(Customize) Click here to add your own URL")
  END IF
END FUNCTION

FUNCTION do_maths_using_dom(op1, op2, operand) 
DEFINE op1, op2 INTEGER
DEFINE operand STRING

DEFINE wsstatus INTEGER
DEFINE result INTEGER
DEFINE remaind INTEGER
DEFINE error_message STRING

DEFINE root_req, root_resp xml.DomNode

    -- Must be able have the variable name instead of _ANY_0

    -- Create the XML Document for the request
    LET DomRequest._ANY_0 = xml.DomDocument.createDocument("document")
    LET root_req = DomRequest._ANY_0.getDocumentElement()
    CALL root_req.setAttribute("a", op1)
    CALL root_req.setAttribute("b", op2)
    CALL root_req.setAttribute("op", operand)

    -- CAll the Web Service
    -- Pass in a xml.domDocument and return web servuce status and an xmlDomDocument
    CALL Dom(DomRequest._ANY_0) RETURNING wsstatus, DomResponse._ANY_0 

    IF wsstatus = 0 THEN
        -- Extract the information from the XML Document returned
        LET root_resp = DomResponse._ANY_0.getDocumentElement()
        LET result = root_resp.getAttribute("r")
        LET remaind = root_resp.getAttribute("m")
        LET error_message = root_resp.getAttribute("error")
    ELSE
        INITIALIZE result, remaind TO NULL
        LET error_message = wsError.description
    END IF
    RETURN wsstatus, result, remaind, error_message
END FUNCTION
